//+------------------------------------------------------------------+
//|                                         My OZFx Squeeze v1.2.mq4 |
//|                                       Copyright  2008, Mas Awoo |
//|                                        original idea system OZFX |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#property copyright "Copyright  2008, Mas Awoo"
#property link      "mailto:mas_awoo@yahoo.com"
//--------------------------------------

extern int MAGICMA                      = 111111111;
extern double Lots                      = 0.1;
extern double MaxLotSize                = 99;
extern double StopLoss                  = 99;
extern int    Slippage                  = 3; 
extern double TakeProfit1               = 50;
extern double TakeProfit2               = 100;
extern double TakeProfit3               = 1111;
extern string Time_to_Open_Order        = "___________________________________________________";
extern bool   Use_Time_to_Entry         = false;
extern int    Start_Order               = 8;
extern int    End_Order                 = 16;
extern string ________Orders________     = "___________________________________________________";
extern bool   Buy                       = true;
extern bool   Sell                      = true;
extern string ____Risk_Management____   = "___________________________________________________";
extern bool   AutoSL                    = false;
extern bool   Use_StopLoss              = false;
extern bool   Use_OppositeSignal        = false;
extern bool   SL_and_OppositeSignal     = true;
extern string ____Money_Management____  = "If true, its calculate Lot for you";
extern bool   MM                        = True;
extern double Risk                      = 0.02;
extern double MaximumRisk               = 0.1;
extern double IncreaseFactor            = 2;
extern string Agresif_Entry_System      = "___________________________________________________ ";
extern bool   AES                       = False;
extern double MaxTrades                 = 20;
extern string _______Chose_one_______   = "___________________________________________________";
extern bool   Active_TrailingStop       = False; //between Active_trailing & Just_BEP you must chose one.
extern double TrailingStop              = 50; 
extern bool   Use_4Step                 = False;
extern double STEP                      = 50;
extern bool   Just_BEP                  = True;
extern double BEP                       = 50;
extern string _____Moving_Average_____  = "MODE: 0=SMA, 1=EMA, 2=SMMA, 3=LWMA ";
extern double MA_PERIODE                = 200;
extern double MODE_MA                   = 0; //0=SMA, 1=EMA, 2=SMMA, 3=LWMA
extern string _______Stochastic_______  = "___________________________________________________";
extern double Stoch_Entry_Buy           = 80;
extern double Stoch_Entry_Sell          = 20;
extern double K_Period                  = 5;
extern double D_Period                  = 3;
extern double Slowing_Period            = 4;
extern string ___Money_Flow_Index_____  = "___________________________________________________";
extern double MFI_Period                = 7;
extern double MFI_Entry_Buy             = 50;
extern double MFI_Entry_Sell            = 50;

//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber ()==MAGICMA )
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   if(sells>0) return(sells);
  }

//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
   double lot=Lots, a;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0, profit=0;                  // number of losses orders without a break
//---- select lot size
 lot=NormalizeDouble(AccountFreeMargin()*Risk/1000.0,1);
if (Lots<0.1)a=2;
else a=1;
//---- calcuulate number of losses orders without a break
   if(IncreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;lot=OrderLots(); 
        }
      if(losses>1) lot=lot*IncreaseFactor;
     }
//---- return lot size
   if(lot<Lots) lot=Lots;
   return(lot);
   if(lot>MaxLotSize ) lot=MaxLotSize;
   if(lot>NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1) ) lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
   return(lot);
  }

//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double AC1, AC2, AO11, AO22, AO1, AO2,St,Sts, MA;
   int    res;
   double TP1, TP2, TP3,SL1,SL2, lots;
   double MFI, Momentum;
//---- go trading only for first tiks of new bar
   if (Volume[0]>1)return;
   if (CalculateCurrentOrders(Symbol())>=MaxTrades)return;
//---- get Moving Average 
   St=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_MAIN,0);
   Sts=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_SIGNAL,0);
   AC1=iCustom(NULL, 0, "Accelerator",1,0);
   AC2=iCustom(NULL, 0, "Accelerator",2,0);
   AO1=iCustom(NULL, 0, "Awesome",1,0);
   AO2=iCustom(NULL, 0, "Awesome",2,0);
   AO11=iCustom(NULL, 0, "Awesome",1,1);
   AO22=iCustom(NULL, 0, "Awesome",2,1);
   MA=iMA(NULL,0,MA_PERIODE,0,MODE_MA,0,0);
   MFI=iMFI(NULL,0,MFI_Period,0);
   Momentum=iMomentum(NULL,0,7,0,0);
   
   if (MM==true)
   lots=LotsOptimized();
   else 
   lots =Lots; 
     if (Use_StopLoss==true)
       {
       if (AutoSL==true )  
       SL1=Ask-(iATR(NULL,PERIOD_H4,21,0)*2)-(Momentum*Point);
       if (AutoSL==false ) 
       SL1=Ask-StopLoss*Point;
       if (AutoSL==false && StopLoss<1) SL1=0;SL2=0;
       }
     if ( SL_and_OppositeSignal==true)
       {
       if (AutoSL==true )  
       SL1=Ask-(iATR(NULL,PERIOD_H4,21,0)*2)-(Momentum*Point);
       if (AutoSL==false ) 
       SL1=Ask-StopLoss*Point;
       if (AutoSL==false && StopLoss<1) SL1=0;
       }
     if (Use_OppositeSignal==true && SL_and_OppositeSignal==false) SL1=0;
     if (Use_OppositeSignal==false && Use_StopLoss==false && SL_and_OppositeSignal==false) SL1=0;
   
//---- Buy conditions
   if(Buy==true && MFI>MFI_Entry_Buy && AC1!=0 &&  AO1!=0 && (AO22<0 || AO11<0)  && St>Stoch_Entry_Buy && St>Sts && Open[0]>MA )
     {
      if (TakeProfit1>0)TP1=Ask+TakeProfit1*Point;
      if (TakeProfit1<=0)TP1=0;
      if (TakeProfit2>0)TP2=Ask+TakeProfit2*Point;
      if (TakeProfit2<=0)TP2=0;
      if (TakeProfit3>0)TP3=Ask+TakeProfit3*Point;
      if (TakeProfit3<=0)TP3=0;
      res=OrderSend(Symbol(),OP_BUY,lots,Ask,Slippage,SL1,TP1,"Mas Awoo",MAGICMA,0,Blue);
      res=OrderSend(Symbol(),OP_BUY,lots,Ask,Slippage,SL1,TP2,"Mas Awoo",MAGICMA,0,Blue);
      res=OrderSend(Symbol(),OP_BUY,lots,Ask,Slippage,SL1,TP3,"Mas Awoo",MAGICMA,0,Blue);
      return;
     }
  //----
//---- Sell conditions
     if (Use_StopLoss==true)
       {
       if (AutoSL==true )  
       SL2=Bid+(iATR(NULL,PERIOD_H4,21,0)*2+(Momentum*Point));
       if (AutoSL==false ) 
       SL2=(Bid+StopLoss*Point);
       if (AutoSL==false && StopLoss<1) SL2=0;
       }
     if ( SL_and_OppositeSignal==true)
       {
       if (AutoSL==true )  
       SL2=Bid+(iATR(NULL,PERIOD_H4,21,0)*2+(Momentum*Point));
       if (AutoSL==false ) 
       SL2=Bid+(StopLoss*Point);
       if (AutoSL==false && StopLoss<1) SL2=0;
       }
     if (Use_OppositeSignal==true && SL_and_OppositeSignal==false) SL2=0;
     if (Use_OppositeSignal==false && Use_StopLoss==false && SL_and_OppositeSignal==false)SL2=0;
   if(Sell==true && MFI<MFI_Entry_Sell && AC2!=0 && AO2!=0 && (AO11>0 || AO22>0)  && St<Stoch_Entry_Sell && St<Sts && Open[0]<MA )
     {
      if (TakeProfit1>0)TP1=Bid-TakeProfit1*Point;
      if (TakeProfit1<=0)TP1=0;
      if (TakeProfit2>0)TP2=Bid-TakeProfit2*Point;
      if (TakeProfit2<=0)TP2=0;
      if (TakeProfit3>0)TP3=Bid-TakeProfit3*Point;
      if (TakeProfit3<=0)TP3=0;
      res=OrderSend(Symbol(),OP_SELL,lots,Bid,Slippage,SL2,TP1,"Mas Awoo",MAGICMA,0,Red);
      res=OrderSend(Symbol(),OP_SELL,lots,Bid,Slippage,SL2,TP2,"Mas Awoo",MAGICMA,0,Red);
      res=OrderSend(Symbol(),OP_SELL,lots,Bid,Slippage,SL2,TP3,"Mas Awoo",MAGICMA,0,Red);
      return;
      }
      //----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double AC1, AC2, AO11, AO22, AO1, AO2, St, Sts, MA, MFI;
   int    res;
//---- go trading only for first tiks of new bar
   if (Volume[0]>50)return;
//---- get Moving Average 
   St=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_MAIN,0);
   Sts=iStochastic(NULL,0,K_Period,D_Period,Slowing_Period,MODE_SMA,0,MODE_SIGNAL,0);
   AC1=iCustom(NULL, 0, "Accelerator",1,0);
   AC2=iCustom(NULL, 0, "Accelerator",2,0);
   AO1=iCustom(NULL, 0, "Awesome",1,0);
   AO2=iCustom(NULL, 0, "Awesome",2,0);
   AO11=iCustom(NULL, 0, "Awesome",1,1);
   AO22=iCustom(NULL, 0, "Awesome",2,1);
   MA=iMA(NULL,0,MA_PERIODE,0,MODE_MA,0,0);
   MFI=iMFI(NULL,0,MFI_Period,0);
   

//---- get Moving Average 
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()==MAGICMA && OrderSymbol()==Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
        if( MFI<MFI_Entry_Sell && AC2!=0 && AO2!=0 && (AO11>0 || AO22>0)  && St<Stoch_Entry_Sell && St<Sts && Open[0]<MA )
          OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
        }
      if(OrderType()==OP_SELL)
        {
        if( MFI>MFI_Entry_Buy && AC1!=0 &&  AO1!=0 && (AO22<0 || AO11<0)  && St>Stoch_Entry_Buy && St>Sts && Open[0]>MA )
         OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
        }
     }

  }
//+------------------------------------------------------------------+
//| Manage Order                                        |
//+------------------------------------------------------------------+
void ManageOrder ()
{
double total, cnt;
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderMagicNumber ()==MAGICMA 
         && OrderSymbol()==Symbol())   
        {
         if(OrderType()==OP_BUY)  
           {
           if(Just_BEP==true && BEP>0)
             {                 
              if(Bid-OrderOpenPrice()>Point*BEP && OrderStopLoss()!=OrderOpenPrice())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
                 }
             }
           if(Use_4Step==true && STEP>0)
              {                 
               if(Bid-OrderOpenPrice()>Point*STEP && OrderOpenPrice()!=OrderStopLoss() &&  OrderOpenPrice()>OrderStopLoss() )
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Blue);
                 }
               if(Bid-OrderStopLoss()>Point*(STEP+STEP)&& OrderOpenPrice()<=OrderStopLoss())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*STEP,OrderTakeProfit(),0,Blue);
                 }
              }
             if(Active_TrailingStop==true && TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Blue);
                    }
                 }
              }
           }
         else //
           {
           if(Just_BEP==true && BEP>0)
              {                 
               if((OrderOpenPrice()-Ask)>(Point*BEP) && OrderStopLoss()!=OrderOpenPrice())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                 }
              }
            if(Use_4Step==true && STEP>0)
              {                 
               if(OrderOpenPrice()-Ask>Point*STEP && OrderOpenPrice()!=OrderStopLoss() && OrderOpenPrice()<OrderStopLoss())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Red);
                 }
               if((OrderStopLoss()-Ask)>(Point*(STEP+STEP)) && OrderOpenPrice()>=OrderStopLoss())
                 {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*STEP,OrderTakeProfit(),0,Red);
                 }
              }
            if(Active_TrailingStop==true && TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if(OrderStopLoss()==0.0 || 
                     OrderStopLoss()>(Ask+Point*TrailingStop))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                    }
                 }
              }
           }
        }
     }
     return(0);
     }

//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())>0) ManageOrder();
   if (Use_Time_to_Entry==true)
   {
    if (Hour()>=Start_Order && Hour()<=End_Order )
    {
    if(CalculateCurrentOrders(Symbol())<1) CheckForOpen();
    if (SL_and_OppositeSignal==true || Use_OppositeSignal==true)  CheckForClose();
    if(AES==True && CalculateCurrentOrders(Symbol())>0 && CalculateCurrentOrders(Symbol())<MaxTrades) 
     CheckForOpen();
    }
   }
   else
   {
    if(CalculateCurrentOrders(Symbol())<1) CheckForOpen();
    if (SL_and_OppositeSignal==true || Use_OppositeSignal==true)  CheckForClose();
    if(AES==True && CalculateCurrentOrders(Symbol())>0 && CalculateCurrentOrders(Symbol())<MaxTrades) 
    CheckForOpen();
   }

//----
  }
//+------------------------------------------------------------------+